import "antd/es/menu/style";
import _Menu from "antd/es/menu";

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _get(target, property, receiver) { if (typeof Reflect !== "undefined" && Reflect.get) { _get = Reflect.get; } else { _get = function _get(target, property, receiver) { var base = _superPropBase(target, property); if (!base) return; var desc = Object.getOwnPropertyDescriptor(base, property); if (desc.get) { return desc.get.call(receiver); } return desc.value; }; } return _get(target, property, receiver || target); }

function _superPropBase(object, property) { while (!Object.prototype.hasOwnProperty.call(object, property)) { object = _getPrototypeOf(object); if (object === null) break; } return object; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

import PropTypes from 'prop-types';
import React from 'react';
import { Proxy0, SK } from 'sk-js';
import OriginMenu from './OriginMenu';
import SKMenuItem from './SKMenuItem';
import SKSubMenu from './SKSubMenu';
import AntdComp from '../AntdComp';
import SKIcon from '../icon/SKIcon';
/**
 * if ssClick, must modelId
 * if ssOpenChange, must openKeysId
 */

var SKMenu =
/*#__PURE__*/
function (_AntdComp) {
  _inherits(SKMenu, _AntdComp);

  function SKMenu() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, SKMenu);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(SKMenu)).call.apply(_getPrototypeOf2, [this].concat(args)));
    _this.state = {
      openKeys: [],
      selectedKeys: []
    };
    _this.SK_COMP_NAME = SKMenu.SK_COMP_NAME;

    _this.handleClick = function (clickInfo) {
      if (_this.props.ssClick && Proxy0._.isFunction(_this.props.ssClick)) {
        _this.props.ssClick(clickInfo);
      } else {
        if (_this.getModelId()) {
          _this.n2m([clickInfo.key]);
        } else {
          _this.setState({
            selectedKeys: [clickInfo.key]
          });
        }
      }
    };

    _this.handleOpenChange = function (openKeys) {
      if (_this.props.ssOpenChange && Proxy0._.isFunction(_this.props.ssOpenChange)) {
        _this.props.ssOpenChange(openKeys);
      } else {
        if (_this.props.openKeysId) {
          _this.skModel().skVal(_this.props.openKeysId, openKeys);
        } else {
          _this.setState({
            openKeys: openKeys
          });
        }
      }
    };

    _this.menuMap = function (itemInfo) {
      var displayItem = _this.props.displayItem;
      var rtnMenu = undefined;

      if (displayItem && displayItem(itemInfo)) {
        if (itemInfo.children && !Proxy0._.isEmpty(itemInfo.children)) {
          // {...this.skTransProps2Self(SKSubMenu)} // deleted it for fixed horizontal
          rtnMenu = React.createElement(SKSubMenu, {
            eventKey: itemInfo.router,
            key: itemInfo.router,
            title: React.createElement("span", null, itemInfo.icon && React.createElement(SKIcon, {
              type: itemInfo.icon
            }), React.createElement("span", null, itemInfo.title))
          }, itemInfo.children.map(_this.menuMap));
        } else if (itemInfo.divider) {
          rtnMenu = React.createElement(_Menu.Divider, {
            key: itemInfo.router
          });
        } else {
          // {...this.skTransProps2Self(SKMenuItem)} // deleted it for fixed horizontal
          rtnMenu = React.createElement(SKMenuItem, {
            eventKey: itemInfo.router,
            key: itemInfo.router
          }, itemInfo.icon && React.createElement(SKIcon, {
            type: itemInfo.icon
          }), React.createElement("span", null, itemInfo.title));
        }
      }

      return rtnMenu;
    };

    return _this;
  }

  _createClass(SKMenu, [{
    key: "addExtendChangedMonitor",
    value: function addExtendChangedMonitor() {
      _get(_getPrototypeOf(SKMenu.prototype), "addExtendChangedMonitor", this).call(this);

      this.addChangedMonitor(this.props.dataId);
      this.addChangedMonitor(this.props.openKeysId);
    }
  }, {
    key: "rmvExtendChangedMonitor",
    value: function rmvExtendChangedMonitor() {
      _get(_getPrototypeOf(SKMenu.prototype), "rmvExtendChangedMonitor", this).call(this);

      this.rmvChangedMonitor(this.props.dataId);
      this.rmvChangedMonitor(this.props.openKeysId);
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props = this.props,
          CompTag = _this$props.compTag,
          data = _this$props.data,
          dataId = _this$props.dataId,
          openKeysId = _this$props.openKeysId,
          theme = _this$props.theme;
      return React.createElement(CompTag, _extends({}, this.skTransProps2Self(CompTag), {
        onClick: this.handleClick,
        onOpenChange: this.handleOpenChange,
        openKeys: openKeysId ? this.skModel().skVal(openKeysId) : this.state.openKeys,
        selectedKeys: this.getModelId() ? this.m2n() : this.state.selectedKeys,
        theme: theme
      }), data || dataId ? (dataId ? this.skModel().skVal(dataId) : SK.s4a(data)).map(function (itemInfo) {
        return _this2.menuMap(itemInfo);
      }) : this.skTransProps2Child());
    }
  }]);

  return SKMenu;
}(AntdComp);

SKMenu.SK_COMP_NAME = 'SKMenu';
SKMenu.defaultProps = SK.extends(true, {}, AntdComp.defaultProps, SKMenuItem.defaultProps, SKSubMenu.defaultProps, OriginMenu.defaultProps, {
  compTag: _Menu,
  displayItem: function displayItem(itemInfo) {
    return true;
  }
});
SKMenu.propTypes = SK.extends(true, {}, AntdComp.propTypes, SKMenuItem.propTypes, SKSubMenu.propTypes, OriginMenu.propTypes, {
  data: PropTypes.array,
  dataId: PropTypes.string,
  displayItem: PropTypes.func,
  openKeysId: PropTypes.string.isRequired,
  ssClick: PropTypes.func,
  ssOpenChange: PropTypes.func
});
export { SKMenu as default };