"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _skJs = require("sk-js");

var _AntdComp2 = _interopRequireDefault(require("../AntdComp"));

var _SKCol = _interopRequireDefault(require("../col/SKCol"));

var _SKFormItem = _interopRequireDefault(require("../form/SKFormItem"));

var _SKPopover = _interopRequireDefault(require("../popover/SKPopover"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

/**
 * @MustModels
 */
var FormComp =
/*#__PURE__*/
function (_AntdComp) {
  _inherits(FormComp, _AntdComp);

  function FormComp() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, FormComp);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(FormComp)).call.apply(_getPrototypeOf2, [this].concat(args)));
    _this.SK_COMP_NAME = FormComp.SK_COMP_NAME;
    return _this;
  }

  _createClass(FormComp, [{
    key: "render",
    value: function render() {
      var inFormRow = this.skBfo(FormComp.SK_PROPS.IN_FROM_ROW);
      var needFormItem = this.skBfo(FormComp.SK_PROPS.NEED_FROM_ITEM);
      var errorObj = this.skModel().getErrors(this.getModelId());
      var help = _skJs.Proxy0._.isEmpty(errorObj) ? _skJs.SK.STR_EMPTY : _skJs.Proxy0._.join(errorObj.skVals(), _skJs.SK.CHAR_BLANK + _skJs.SK.CHAR_AMPERSAND + _skJs.SK.CHAR_AMPERSAND + _skJs.SK.CHAR_BLANK);
      var validateStatus = _skJs.Proxy0._.isEmpty(errorObj) ? _skJs.SK.STR_EMPTY : _skJs.SK.STR_ERROR;

      if (inFormRow && needFormItem) {
        return _react.default.createElement(_SKCol.default, this.skTransProps2Self(_SKCol.default), this.renderFormItem(help, validateStatus));
      } else if (inFormRow && !needFormItem) {
        return _react.default.createElement(_SKCol.default, this.skTransProps2Self(_SKCol.default), this.renderFormComp(help, validateStatus));
      } else if (!inFormRow && needFormItem) {
        return this.renderFormItem(help, validateStatus);
      } else {
        return this.renderFormComp(help, validateStatus);
      }
    }
  }, {
    key: "renderFormComp",
    value: function renderFormComp(help, validateStatus) {
      if (this.skBfo(FormComp.SK_PROPS.HELP_ON_COMP) && !_skJs.Proxy0._.isNil(help) && !_skJs.Proxy0._.isNil(validateStatus)) {
        return _react.default.createElement(_SKPopover.default, {
          content: help,
          title: validateStatus
        }, this.renderFormCompWithoutHelp());
      } else {
        return this.renderFormCompWithoutHelp();
      }
    }
  }, {
    key: "renderFormCompWithoutHelp",
    value: function renderFormCompWithoutHelp() {
      var _this$props = this.props,
          CompTag = _this$props.compTag,
          modelId = _this$props.modelId;
      return _react.default.createElement(CompTag, _extends({}, this.skTransProps2Self(CompTag), {
        modelId: modelId
      }), this.skTransProps2Child());
    }
  }, {
    key: "renderFormItem",
    value: function renderFormItem(help, validateStatus) {
      return _react.default.createElement(_SKFormItem.default, _extends({}, this.skTransProps2Self(_SKFormItem.default, this.props), {
        help: help,
        label: this.props.label,
        required: this.skBfo(_AntdComp2.default.SK_PROPS.REQUIRED),
        validateStatus: validateStatus
      }), this.renderFormComp());
    }
  }]);

  return FormComp;
}(_AntdComp2.default);

exports.default = FormComp;
FormComp.SK_COMP_NAME = 'FormComp';
FormComp.SK_PROPS = _skJs.SK.extends(true, {}, _AntdComp2.default.SK_PROPS, {
  HELP_ON_COMP: 'helpOnComp',
  IN_FROM_ROW: 'inFormRow',
  NEED_FROM_ITEM: 'needFormItem'
});
FormComp.defaultProps = _skJs.SK.extends(true, {}, _AntdComp2.default.defaultProps, _SKCol.default.defaultProps, _SKFormItem.default.defaultProps, {});
FormComp.propTypes = _skJs.SK.extends(true, {}, _AntdComp2.default.propTypes, _SKCol.default.propTypes, _SKFormItem.default.propTypes, {
  helpInLabel: _propTypes.default.bool,
  inFormRow: _propTypes.default.bool,
  skInFormRow: _propTypes.default.bool,
  needFormItem: _propTypes.default.bool,
  skNeedFormItem: _propTypes.default.bool
});