"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("antd/es/table/style");

var _table = _interopRequireDefault(require("antd/es/table"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _skJs = require("sk-js");

var _AntdComp2 = _interopRequireDefault(require("../AntdComp"));

var _AntdConst = require("../AntdConst");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

_table.default.defaultProps = _skJs.SK.extends(true, {}, {
  bordered: false,
  defaultExpandAllRows: false,
  expandRowByClick: false,
  indentSize: 15,
  loading: false,
  rowSelection: null,
  showHeader: true,
  size: _AntdConst.SIZE.Default
}, _table.default.defaultProps, {});
_table.default.propTypes = _skJs.SK.extends(true, {}, {
  //https://ant.design/components/table-cn/#Table
  bordered: _propTypes.default.bool,
  columns: _propTypes.default.array,
  components: _propTypes.default.object,
  dataSource: _propTypes.default.array,
  defaultExpandAllRows: _propTypes.default.bool,
  defaultExpandedRowKeys: _propTypes.default.array,
  expandedRowKeys: _propTypes.default.array,
  expandedRowRender: _propTypes.default.func,
  expandRowByClick: _propTypes.default.bool,
  footer: _propTypes.default.func,
  indentSize: _propTypes.default.number,
  loading: _propTypes.default.any,
  //
  locale: _propTypes.default.object,
  pagination: _propTypes.default.object,
  rowClassName: _propTypes.default.func,
  rowKey: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.func]),
  rowSelection: _propTypes.default.object,
  scroll: _propTypes.default.object,
  showHeader: _propTypes.default.bool,
  size: _propTypes.default.string,
  title: _propTypes.default.func,
  onChange: _propTypes.default.func,
  onExpand: _propTypes.default.func,
  onExpandedRowsChange: _propTypes.default.func,
  onHeaderRow: _propTypes.default.func,
  onRow: _propTypes.default.func
}, _table.default.propTypes, {});
_table.default.NON_SK_COMP_NAME = 'Table';
/**
 * @MustModelId
 * @NoChild
 */

var SKTable =
/*#__PURE__*/
function (_AntdComp) {
  _inherits(SKTable, _AntdComp);

  function SKTable() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, SKTable);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(SKTable)).call.apply(_getPrototypeOf2, [this].concat(args)));
    _this.SK_COMP_NAME = SKTable.SK_COMP_NAME;
    return _this;
  }

  _createClass(SKTable, [{
    key: "addExtendChangedMonitor",
    value: function addExtendChangedMonitor() {
      this.addChangedMonitor(this.props.loadingId);
      this.addChangedMonitor(this.props.paginationId);
    }
  }, {
    key: "rmvExtendChangedMonitor",
    value: function rmvExtendChangedMonitor() {
      this.rmvChangedMonitor(this.props.loadingId);
      this.rmvChangedMonitor(this.props.paginationId);
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
          CompTag = _this$props.compTag,
          columns = _this$props.columns,
          scroll = _this$props.scroll;
      var tmpScroll = {
        y: false
      };
      tmpScroll.x = columns.reduce(function (sum, item) {
        return sum + item.width;
      }, 0);
      tmpScroll = scroll || tmpScroll;
      return _react.default.createElement(CompTag, _extends({}, this.skTransProps2Self(CompTag), {
        dataSource: this.m2n(),
        loading: this.skModel().skVal(this.props.loadingId),
        pagination: this.skModel().skVal(this.props.paginationId),
        scroll: tmpScroll
      }));
    }
  }]);

  return SKTable;
}(_AntdComp2.default);

exports.default = SKTable;
SKTable.SK_COMP_NAME = 'SKTable';
SKTable.defaultProps = _skJs.SK.extends(true, {}, _AntdComp2.default.defaultProps, _table.default.defaultProps, {
  compTag: _table.default,
  bordered: true,
  loadingId: undefined,
  paginationId: undefined
});
SKTable.propTypes = _skJs.SK.extends(true, {}, _AntdComp2.default.propTypes, _table.default.propTypes, {
  loadingId: _propTypes.default.string.isRequired,
  paginationId: _propTypes.default.string.isRequired
});